<script setup lang="ts">
import DeleteModal from "@/components/modals/DeleteModal.vue";
import type { BucketOut } from "@/client/types.gen.ts";
import { useNameStore, useUserStore } from "@/stores";

const props = defineProps<{
  modalId: string;
  bucket?: BucketOut;
  backModalId?: string;
}>();

const emit = defineEmits<{
  (e: "confirm-delete", bucketName: string): void;
}>();
const userRepository = useUserStore();
const nameRepository = useNameStore();

function deleteBucket() {
  if (props.bucket != undefined) {
    emit("confirm-delete", props.bucket.name);
    window._paq?.push(["trackEvent", "Delete", "bucket"]);
  }
}
</script>

<template>
  <delete-modal
    :modal-id="props.modalId"
    :back-modal-id="props.backModalId"
    delete-type="Bucket"
    :disabled="props.bucket == undefined"
    @confirm-delete="deleteBucket"
  >
    <template #body>
      <p>
        Are you sure you want to delete the bucket
        <strong v-if="props.bucket">{{ props.bucket.name }}</strong>
        <template
          v-if="
            props.bucket?.owner_id &&
            props.bucket.owner_id !== userRepository.currentUID
          "
        >
          from the user
          <strong>{{
            nameRepository.getName(props.bucket.owner_id)
          }}</strong> </template
        >?<br />
        All files inside this bucket will be deleted to and won't be accessible
        anymore.
      </p>
    </template>
  </delete-modal>
</template>

<style scoped></style>
